LPARAMETERS tcFolder_ini, tcProgram_Name

#INCLUDE [..\theocall_def.h]
#DEFINE MENSAJE_DE	"Mensaje de TheoCall"
SET DEBUG OFF
SET SAFETY OFF
SET DATE TO BRITISH
SET CENTURY ON
SET DELETED ON
set BELL OFF
SET STATUS OFF
set STATUS BAR OFF
SET SCORE OFF
SET TALK OFF
SET NOTIFY OFF
SET NEAR OFF
SET ESCAPE OFF
SET UNIQUE OFF
SET FIXED OFF
SET EXACT OFF
SET CONF ON
SET FDOW TO 2
SET OLEOBJECT ON
SET LOGERRORS OFF
SET HOURS TO 24

ON SHUTDOWN do MyQuit

TRY
	LOCAL lcRoot,;
		lcFolder_Reposit,;
		loActuali AS Object,;
		loCopy AS Object,;
		loEx AS Exception,;
		loFile AS Object,;
		loFso AS Object,;
		loParam AS Object,;
		loResp AS Object,;
		loShell AS Object,;
		loShortCut as Object
		

	IF VARTYPE(m.tcProgram_Name)#"C" ;
		OR EMPTY(m.tcProgram_Name)
		tcProgram_Name = ""
	ENDIF 
	tcProgram_Name = CHRTRAN(m.tcProgram_name,CHR(47),"")
	
	* Por versiones anteriores de Theocall
	IF !EMPTY(m.tcFolder_Ini) AND EMPTY(m.tcProgram_name)
		tcProgram_Name = "theodore.exe"
	ENDIF 
	*
	lcFolder_Reposit = ""
	lcRoot = miCurDir()
		
	IF _vfp.StartMode = 0
		SET DEFAULT TO c:\Desa\TheoCall
		SET PATH TO c:\Desa\TheoCall\libs,;
				c:\Desa\TheoCall\progs
		lcRoot = "c:\desa\theocall"
	ENDIF 
	
	CD &lcRoot

	loFso = NEWOBJECT("Scripting.FileSystemObject")

	Get_fdb_Semaf("beautify",m.lcRoot)

	DO WHILE .t.
		
		*!*		Si se omite el parmetro tcFolder_Ini,
		*!*		significa que el programa se lanz desde el Explorador de Windows 
		*!*		y es necesario definir la ruta de la aplicacin (theodore.exe)
		
		IF EMPTY(m.tcFolder_ini)
			loShortCut = Create_ShortCut(m.lcRoot,m.tcProgram_Name,loFso)

			IF VARTYPE(loShortCut)#"O" ;
				OR EMPTY(loShortCut.Folder_Ini);
				OR EMPTY(loShortCut.Program_name)			
				EXIT
			ENDIF 
			tcFolder_Ini = loShortCut.Folder_ini
			tcProgram_Name = loShortCut.Program_Name
			lcFolder_Reposit = loShortCut.Folder_Reposit
		ENDIF 
 
		IF !loFso.FolderExists(ADDBS(m.tcFolder_Ini))
			MESSAGEBOX("No se encuentra la carpeta "+m.tcFolder_Ini,0,MENSAJE_DE)
			EXIT 
		ENDIF 	

		loParam = NEWOBJECT("Empty")
		ADDPROPERTY(loParam,"Folder_Ini",m.tcFolder_ini)	
		ADDPROPERTY(loParam,"Local_Program",ADDBS(m.tcFolder_Ini) + m.tcProgram_Name)				
		ADDPROPERTY(loParam,"Program_Name",m.tcProgram_Name)	
		ADDPROPERTY(loParam,"File_Info",ADDBS(lcRoot) + "theocall.cfg"	)
		ADDPROPERTY(loParam,"Exist_LocalProgram",.f.)
		ADDPROPERTY(loParam,"source_file","")
		ADDPROPERTY(loParam,"target_file","")
		ADDPROPERTY(loParam,"folder_Reposit",m.lcFolder_Reposit)

		loResp = if_Program_Open(m.loParam.Local_Program,loFso)
		IF VARTYPE(loResp)#"O" ;
			OR loResp.lError ;
			OR loResp.Program_Open
			EXIT 
		ENDIF 
		
		loParam.Exist_LocalProgram = loResp.Program_Exists
		
	 	loActuali = if_actualize(loParam,loFso)
	 	
	 	IF VARTYPE(loActuali)#"O"
	 		EXIT
	 	ENDIF 
	 	IF VARTYPE(loActuali)="O"
		 	loParam.Source_file = loActuali.exe_Source
		 	loParam.Target_File = loActuali.exe_Target

			IF loActuali.Actualizar
				loCopy = do_Actualizar(loParam,loFso)
				IF VARTYPE(loCopy) = "O"
				
					loParam.Exist_LocalProgram = loCopy.exist_targetFile
					IF !loCopy.doCopy
						MESSAGEBOX(LOWER(loParam.Target_file)+" no pudo actualizarse",0,MENSAJE_DE,3000)
					ENDIF 
						
				ENDIF 
		
			ENDIF 
		ENDIF 
		
		*<Ejecutar Programa>
		IF loParam.Exist_LocalProgram
			TRY 
				LOCAL loOpenErr as Exception 
				loShell=CREATEOBJECT("Shell.Application")
				
				CD &tcFolder_Ini
				loShell.ShellExecute(loParam.Local_Program, "", ADDBS(m.tcFolder_Ini), "open", 3)	
				
			CATCH TO loOpenErr
				loOpenErr.UserValue = PROGRAM()
				ShowError(loOpenErr)
			FINALLY 
			
			ENDTRY 
		ENDIF 
		*</Ejecutar Programa>		
		EXIT 

	ENDDO 
CATCH TO loex
	loex.UserValue=PROGRAM()
	showerror(loEx)
FINALLY
	loParam = null
 	loResp = null
	loShell = null
	loFile = null
	loFso = null
	loCopy = null
	loShortCut = null

ENDTRY
QUIT
ENDPROC 

PROCEDURE if_Actualize
*------------------------
LPARAMETERS toParam,toFso

TRY 

	LOCAL LOEX AS EXCEPTION,;
		loFile as Object,;
		loInf as Object,;
		lcFolder_Source,;
		lExist_SourceFile,;
		lcFolder_Select


	loInf = NEWOBJECT("Empty")
	ADDPROPERTY(loInf,"dt_Local_Prog",{//::})
	ADDPROPERTY(loInf,"dt_Reposit_Prog",{//::})
	ADDPROPERTY(loInf,"Folder_Source","")
	ADDPROPERTY(loInf,"exe_source","")
	ADDPROPERTY(loInf,"exe_source_exist",.f.)
	ADDPROPERTY(loInf,"exe_target","")
	ADDPROPERTY(loInf,"actualizar",.f.)
			

	TRY 
		IF toParam.Exist_LocalProgram
			loFile = toFso.GetFile(toParam.Local_Program)
			loInf.dt_Local_Prog = loFile.DateLastModified
		ENDIF 
	CATCH 
	
	ENDTRY 
		
	IF toFso.FileExists(toParam.File_Info)
		*	loInf.Folder_Source = Read_Tag_InString(FILETOSTR(toParam.File_Info),"reposit")
		* get_Tag_Value(lcProgram,"reposit",toParam.File_Info)
			
		loInf.Folder_Source = get_Tag_Value(toParam.Program_Name,"reposit",toParam.File_Info)
			
		IF NOT EMPTY(loInf.Folder_Source)
			
			IF !toFso.FolderExists(ADDBS(loInf.Folder_Source))
				loInf.Folder_Source = ""
			ENDIF 
			
		ENDIF 
	ENDIF 
	
	IF EMPTY(loInf.Folder_Source)
		loInf.Folder_Source = toParam.Folder_Reposit
			
		IF !EMPTY(loInf.Folder_source)
			Insert_Tag(toParam.Program_name,Put_Tag("reposit",loInf.folder_Source),toParam.File_Info)
		ENDIF 
	ENDIF 
	IF !EMPTY(loInf.folder_Source)
		loInf.exe_Source = ADDBS(loInf.Folder_Source)+toParam.Program_Name
		loInf.exe_source_exist = toFso.FileExists(loInf.exe_Source)	
	
	ENDIF 


	*<Respositorios>
	IF EMPTY(loInf.Folder_Source) OR !loInf.exe_source_exist
			* Buscar Repositorio
		DO WHILE .t.
			lcFolder_Select = GETDIR(loInf.Folder_Source,"Carpeta fuente de "+PROPER(toParam.Program_Name),"Repositorio de Theodore",48+64)
			IF EMPTY(m.lcFolder_Select)
				lnMess = MESSAGEBOX("No seleccion una carpeta de repositorio para "+PROPER(toParam.Program_Name)+_CR_ ;
					+"Desea Intentarlo nuevamente?",4,MENSAJE_DE)
				IF lnMess # 6
					loInf.Folder_Source = ""
					EXIT 
				ENDIF 
			ENDIF 
			IF RIGHT(m.lcFolder_Select,1)="\"
				lcFolder_Select = LEFT(m.lcFolder_Select,LEN(m.lcFolder_Select)-1)
			ENDIF 
			IF !toFso.FileExists(ADDBS(m.lcFolder_Select)+ toParam.Program_Name)
				MESSAGEBOX(PROPER(toParam.Program_Name)+" no se encuentra en "+_CR_ ;
					+m.lcFolder_Select,0,MENSAJE_DE)
				loInf.Folder_Source = ""
				LOOP 
			ELSE
				loInf.Folder_Source = m.lcFolder_Select
				EXIT 
			ENDIF 
		ENDDO 
		IF !EMPTY(loInf.Folder_Source)
			Insert_Tag(toParam.Program_name,Put_Tag("reposit",loInf.folder_Source),toParam.File_Info)
		ENDIF 
	ENDIF 
	
	IF !EMPTY(loInf.Folder_Source)
	
		TRY 
			loFile = toFso.GetFile(ADDBS(loInf.Folder_Source)+ toParam.Program_Name )
			loInf.dt_Reposit_Prog = loFile.DateLastModified
		CATCH 
		
		ENDTRY 
	
		*<Actualizar>
		loInf.Actualizar = !toParam.Exist_LocalProgram
		
		IF !loInf.Actualizar AND !EMPTY(loInf.dt_Reposit_Prog)
			loInf.Actualizar =  loInf.dt_Reposit_Prog > loInf.dt_Local_Prog 
		ENDIF 
	ENDIF 

CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()		
	SHOWERROR(LOEX)

FINALLY

ENDTRY
RETURN loInf
ENDPROC

PROCEDURE do_actualizar
************************
LPARAMETERS toParam,toFso

TRY 
	LOCAL LOEX AS EXCEPTION,;
		lnMess,;
		lcSourceFile,;
		lcTargetFile,;
		lcFail,;
		loInf as Object,;
		loCopyErr as Exception
		
	loInf = NEWOBJECT("Empty")
	ADDPROPERTY(loInf,"exist_targetfile",toParam.Exist_LocalProgram)
	ADDPROPERTY(loInf,"doCopy",.f.)
	
	lcSourceFile = toParam.Source_File
	lcTargetFile = toParam.local_Program
	
	lnMess = MESSAGEBOX("Necesita Actualizar el Sistema",4,MENSAJE_DE,1000)
	IF m.lnMess = 6 OR m.lnMess = -1


		TRY 
			
			lcFail = "Copy File"		
			lcTargetFile = ADDBS(toParam.Folder_Ini)+toParam.Program_Name
			COPY FILE &lcSourceFile TO &lcTargetFile	
			loInf.DoCopy = .t.
		CATCH TO loCopyErr
			locopyErr.UserValue = PROGRAM() + CHR(13);
				+ "No se puede actualizar el sistema."+CHR(13);
				+ "Source = "+ADDBS(toParam.Folder_Source)+toParam.Program_Name + CHR(13);
				+ "as " + toParam.exe_Source + CHR(13);
				+ "Target = "+ADDBS(toParam.Folder_Ini) + CHR(13);
				+ "Fail in "+m.lcFail + CHR(13);
				+ "Asegrese de que el sistema se encuentre cerrado"
			ShowError(loCopyErr)
		FINALLY 

			loInf.exist_targetfile = toFso.FileExists(toParam.Local_Program)
		ENDTRY 
		

	ENDIF 		
CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOWERROR(LOEX)

FINALLY
	toParam = null
	toFso = null
ENDTRY
RETURN loInf
ENDPROC 



PROCEDURE myquit
*-----------------
*_screen.frmMain = null
CLEAR ALL 
CLEAR EVENTS
ON SHUTDOWN
QUIT

ENDPROC 


PROCEDURE if_program_Open
*------------------------------
LPARAMETERS tcLocalProgram,toFso
TRY 
	LOCAL lnHandle,;
		loEX AS Exception,;
		loFopenErr AS Exception,;
		loOPen AS Object


	lnHandle = -1
	loOpen = NEWOBJECT("Empty")
	ADDPROPERTY(loOpen,"Program_exists",.f.)
	ADDPROPERTY(loOpen,"Program_Open",.f.)
	ADDPROPERTY(loOpen,"lError",.f.)

	loOpen.Program_exists = toFso.FileExists(m.tcLocalProgram)
	
	IF loOpen.Program_exists
		TRY 
			lnHandle = FOPEN(m.tcLocalProgram,1)
			loOpen.Program_Open = IIF(m.lnHandle < 0,.t.,.f.)
	 
		CATCH TO loFopenErr
			loFopenErr.UserValue = PROGRAM()
			loOpen.Program_Open = .t.
		FINALLY
			IF m.lnHandle > -1
				FCLOSE(m.lnHandle)
			ENDIF 
		ENDTRY 
	
		IF loOpen.Program_Open
			IF VARTYPE(loFopenErr)="O"
				ShowError(lofopenErr)
			ELSE 
				MESSAGEBOX("El programa "+m.tcLocalProgram+" est abierto."+CHR(13);
					+ "Debe cerrar ese programa para ejecutar esta aplicacin",0,MENSAJE_DE,1500)
			ENDIF 
		ENDIF 
	
	ENDIF 
CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOWERROR(LOEX)
	loOpen.lError =  .t.
FINALLY

ENDTRY
RETURN loOPen
ENDPROC


*--------------------------------------
PROCEDURE ShowError
LPARAMETERS toExcep,tlNotShow,tcCaption
*--------------------------------------
tcCaption=EVL(tcCaption,MENSAJE_DE)
LOCAL lcMens
lcMens="Fecha "+TRANSFORM(DATETIME());
	+_CR_+"Mensaje: "+toExcep.message;
	+_CR_+"ErrorNo: "+TRANSFORM(toExcep.Errorno);
	+_CR_+"Llamada: "+toExcep.Uservalue 
IF PEMSTATUS(toExcep,"lineno",5) AND VARTYPE(toExcep.lineno)="N"
	lcMens=lcMens+_CR_+"linea "+TRANSFORM(toExcep.lineno)
ENDIF
	
STRTOFILE(m.lcMens + _CR_ + REPLICATE("=",80) + _CR_ ,"TheoCall_Error.log",1)

IF !tlNotShow
	MESSAGEBOX("Se ha producido un error:"+_CR_+lcMens,0,m.tcCaption)
ENDIF

ENDPROC

****************************
PROCEDURE MICURDIR(lVerbose)
****************************
* lVerbose .t. informa
* Determinar el directorio actual por Wscript
**********************************************
LOCAL cdir , objShell
objShell=CreateObject("Wscript.Shell")
cDir=objShell.CurrentDirectory
if lVerbose
	Messagebox(cDir,0,"Directorio Actual")
endif
objShell= null
return cDir
ENDPROC




PROCEDURE WinDesk
*******************
local cMiDoc
oWsh = CREATEOBJECT("WScript.Shell")
*cmidoc=oWsh.SpecialFolders("My Documents")
cmidoc=oWsh.SpecialFolders("Desktop")
owsh=null
return cMiDoc
ENDPROC


****************************************************************
PROCEDURE put_tag
*!* ------------------------------------------------------------
*!*	Put_Tag 	(Crear una Tag para xml )
*!* ------------------------------------------------------------
*!*	tcTag: 		Nombre de etiqueta
*!*	txValue:		Valor de la etiqueta (Types "C,D,T,L,I,N")
*!*	tnLevel:		Cantidad de Tabs que anteceden la etiqueta
*!*	tn_Add_CR:		Si devuelve un retorno de carro:
*!*					.f. No
*!*					.t. 1 retorno
*!*					0 	No
*!*					1	1 retorno
*!*					2	2 retornos
*!* ------------------------------------------------------------
*!*	For xml Attribute Value  tcTag="Class,name,Pirincho"  ->  [ Class name="Pirincho" ]				
*!* ------------------------------------------------------------
*!* tnFlag_Char_EofLine
*!*		.f.,.t.,0		CHR(13) + CHR(10)
*!*		1				CHR(13)
*!*		2				CHR(10)
*!* Cualquier valor mayor que 2, funciona = 0
*!* ------------------------------------------------------------
*!*
*!*	tnFlag
*!* ---------------------------
*!*	0 - No hace nada (Default)
*!*	1 - Avoid format number or Format Date or Format Datetime
*!*	3 - For Datetime Use Xml Format 
*!*	
*!* ------------------------------------------------------------

LPARAMETERS tcTag,txValue,tnLevel,tn_Add_CR ,tnFlag_Char_EofLine ,tnFlag

tnLevel=EVL(tnLevel,0)
tnFlag = EVL(tnflag,0)
				
TRY 
	LOCAL i_,;
		lcChar_EofLine,;
		lcmask,;
		lcReturn,;
		lcTag_Passed,;
		lcValue,;
		lcVartype,;
		lnCommas,;
		lnCarriage_Return,;
		lnlines,;
		loex AS Exception

		
	lcTag_Passed = tcTag	

	IF VARTYPE(m.tnFlag_Char_EofLine)#"N"
		tnFlag_Char_EofLine = 0
	ENDIF 
	lcChar_EofLine = ICASE(m.tnFlag_Char_EofLine = 1, CHR(13),;
					tnFlag_Char_EofLine = 2 , CHR(10),;
					CHR(13)+CHR(10))
					
	LOCAL ARRAY laLines(1)

	tcTag=ALLTRIM(tcTag)

	*<xml_Attribute>
	lnCommas = OCCURS(_COMA_,tcTag)
	IF lnCommas > 1
		lcValue = ""
		lnLines=ALINES(laLines , tcTag , 2 ,_COMA_)
		FOR i_=3 TO lnLines
			lcValue = m.lcValue + lalines[i_]
		NEXT
		tcTag = laLines[1]+" "+ALLTRIM(lalines[2])+CHR(61) ;
			+IIF(EMPTY(m.lcValue),_COMID_+_COMID_,_COMID_+m.lcValue+_COMID_)
		
		*STRTOFILE( "tcTag="+tctag+"| lcValue="+m.lcValue + _CR_ , "put_tag.txt",1)
			
	ENDIF
	*</xml_Attribute>




	lnCarriage_Return = ICASE(VARTYPE(tn_Add_CR)="L",	IIF(tn_Add_CR,1,0) , ;
				VARTYPE(tn_Add_CR)="N" , tn_Add_CR , ;
				0 )
				
	IF ISNULL(txValue)
		lcREturn=+"<"+m.tcTag+">"
	ELSE
		lcVartype=VARTYPE(m.txValue)
		DO CASE 
			CASE m.lcVartype="N"
				lcValue = TRANSFORM(m.txValue)	
			CASE m.lcVartype="D"
				lcValue = IIF(m.tnFlag=1,DTOS(m.txValue),TRANSFORM(m.txValue))
				
			CASE m.lcVartype="T"
				lcValue = IIF(INLIST(m.tnFlag,1,3),TTOC(m.txValue,m.tnFlag),TRANSFORM(m.txValue))
			
			CASE m.lcVartype = "O"
				lcValue = "(Object)"
			OTHERWISE
			
				lcValue=ICASE(m.lcVartype$'IL',TRANSFORM(m.txValue),;
					lcVartype="C",ALLTRIM(m.txValue),;
					m.txValue)
		ENDCASE 
		
		lcReturn = IIF(lnCommas=0,;
				"<"+tcTag+">" + m.lcValue +"</" + m.tcTag +">", ;
				"<"+tcTag+" />")
				
	ENDIF
CATCH TO loex
	loex.UserValue = PROGRAM() + _CR_;
		+"lcTag_Passed= "+lcTag_Passed + _CR_;
		+"Value = "+IIF(VARTYPE(m.txValue)="C",m.txValue,TRANSFORM(m.txValue))
	showError(loex)
FINALLY
ENDTRY 

RETURN REPLICATE(_TAB_,m.tnLevel) ;
		+ m.lcReturn ;
		+ REPLICATE(m.lcChar_EofLine,m.lnCarriage_Return )
		
ENDPROC 

PROCEDURE Read_Tag_InString
*---------------------------
* tcString: String tipo xml (puede contener varias etiquetas)
* tcTag: Nombre de etiqueta
* tcType: Tipo de valor que devuelve (Character por defecto)
* ------------------------------------------------------------
* Funciones de las que depende
* 	Read_Tag()
* 	MiCtod()
* 	convert_Literal_to_DateTime()
* ------------------------------------------------------------
LPARAMETERS tcString,tcTag,tcType
TRY 
	LOCAL lcExtrae,lxValue,loex as Exception
	tcType = EVL(m.tcType,"C")
	lxValue = ICASE(m.tcType = "C","",;
			m.tcType $ 'NI',0,;
				m.tcType = "L" ,.f.,;
				m.tcType = "D" , {},;
				m.tcType = "T", {//::},;
				"")
	lcExtrae = STREXTRACT(m.tcString,"<"+m.tcTag+">","</"+m.tcTag+">",1,4)
	IF !EMPTY(m.lcExtrae)
		lxValue = REad_tag(m.lcExtrae,m.tcType)
	ENDIF 
CATCH TO loex
	loex.UserValue = PROGRAM()
	showerror(loex)
FINALLY

ENDTRY 
RETURN m.lxValue
ENDPROC 


				

PROCEDURE Read_Tag
*******************
LPARAMETERS tcTag , tcValue_Return

*!*	Revelar el contenido de etiquetas xml
*!*	tcValue_Return puede ser "C,N,I,D,T,L"

TRY 
	LOCAL lnLen,;
		lnAt,;
		lcSub,;
		lcNameTag,;
		lxReturn,;
		loEx as Exception
		
		
	lxReturn = ""
	tcValue_Return = UPPER(EVL(m.tcValue_Return,"C"))
	
	tcTag = ALLTRIM(m.tcTag)
	lnLen = LEN(m.tcTag)
	lnAt = AT(_TAGEND_ , m.tcTag)

	DO CASE 
		CASE lnAt = 0
		
		CASE lnAt = LEN(tcTag)
			* <rubro name="Pachon" />
			IF RIGHT(tcTag,2) == _TAGCRASH_
				lxReturn = TRIM(CHRTRAN(STREXTRACT(tcTag,"=",_TAGCRASH_),_COMID_,""))
			ENDIF 
		OTHERWISE
			lcSub = SUBSTR(m.tcTag,1,m.lnAt)
			
			IF AT(_TAGNAME_ , m.lcSub) > 0

				lcNameTag = STREXTRACT(m.lcSub,_TAGOPEN_,_SPA_)
				lcEnd = "</"+ m.lcNameTag + ">"
				lxReturn = STREXTRACT(tcTag,_TAGEND_,m.lcEnd,1)
				* <alj nm="ABUSERVI:FEC">
				*<d1>01/08/2011</d1><d2>31/08/2011</d2><lg>.T.</lg></alj>
				
			ELSE 
				IF AT(_SPA_,m.lcSub)=0
					* <folder>c:\theodore\forms</folder>
					lxReturn = STREXTRACT(m.tcTag , ;
						SUBSTR(m.tcTag,1,AT(_TAGEND_,m.tcTag,1)),;
						STUFF(SUBSTR(tcTag,1,AT(_TAGEND_,tcTag,1)), 2 , 0, _DIVIDE_))			

					
				ENDIF 
			ENDIF 
		
		
	ENDCASE
	DO CASE 
		CASE m.tcValue_Return = "C"
		CASE m.tcValue_Return = "N"
			lxReturn = VAL(m.lxReturn)
		CASE m.tcValue_Return = "I"
			lxReturn = INT(VAL(m.lxReturn))
		CASE m.tcValue_Return = "L"
			lxReturn = IIF(BETWEEN(LEN(m.lxReturn),1,3) AND ATC("t",m.lxReturn)>0 ,.t.,.f.)
		CASE m.tcValue_Return = "D"
			lxReturn = MiCtod(m.lxReturn)
		CASE m.tcValue_Return = "T" 
			*lxReturn = convert_Literal_to_DateTime(m.lxReturn)
			lxReturn = convert_String_to_Datetime(m.lxReturn)
	ENDCASE 
CATCH TO loEx
	loex.UserValue = PROGRAM()
	ShowError(loEx)
	lxReturn = ""
FINALLY


ENDTRY 

RETURN m.lxReturn
ENDPROC 

*****************
PROCEDURE MiCtod
*****************
LPARAMETERS tcDate
* Convierte, si es posible, una exp. Date literal en un valor Date
* Entrada " //  " , Tambin es posible enviar "20150904"
LOCAL ldReturn,ln
LOCAL ARRAY laDate(1)

TRY
	tcDate = EVL(tcDate,"//")
	IF OCCURS(_DIVIDE_,m.tcDate)=0
		tcDate = Cnv_amd_to_LitDate(m.tcDate)
	ENDIF 
	ldReturn = {}

 
	ln = ALINES(laDate,tcDate,1,_DIVIDE_)
	IF ln = 3
		ldReturn = DATE(VAL(laDate[3]),VAL(laDate[2]),VAL(laDate[1]))
	ENDIF 
CATCH 
	ldReturn = {}
ENDTRY 

RETURN ldReturn
ENDPROC 

*******************************
PROCEDURE StrProgram
LPARAMETERS tcExclude,tcSeparator
*******************************
TRY 
	LOCAL nItems,i,cProg,lcExact,lcString,loex as Exception
	*lcExact=SET("Exact")
	lcString = ""
	*tcExclude = UPPER(EVL(tcExclude,","))
	*tcExclude = _COMA_+tcExclude+_COMA_+"STRPROGRAM"+_COMA_
	
	tcSeparator = EVL(m.tcSeparator,_CR_)
	tcExclude = _COMA_ ;
		+ UPPER(EVL(m.tcExclude,"")) ;
		+ _COMA_ ;
		+ "STRPROGRAM" ;
		+ _COMA_ 
		
	*SET EXACT ON
	*nItems=0
	FOR i=1 TO 128
	*	nItems=i
		cprog=PROGRAM(i)
		IF EMPTY(cProg)
			EXIT
		ENDIF
		IF AT( _COMA_ + m.cprog + _COMA_ , m.tcExclude) = 0
			lcString = m.lcString ;
				+ cProg ;
				+ m.tcSeparator
		ENDIF
	NEXT

CATCH TO loex
	loex.UserValue=PROGRAM()
	ShowError(loex)
FINALLY
	*SET EXACT &lcExact
ENDTRY 
RETURN m.lcString

ENDPROC



PROCEDURE convert_String_to_Datetime
*-----------------------------------
LPARAMETERS tcDateTime , tnMonth_Position , tl_Object

#DEFINE _DEFAULT_PMONTH_	2

* tcDateTime my be character or numeric

*<transform(datetime())
	* YMD: 2016/05/07 09:13:28 PM , yyyy/mm/dd
	* BRITISH, FRENCH, GERMAN: 07/05/2016 09:15:31 PM , dd/mm/yyyy
	* AMERICAN, USA:  05/07/2016 09:14:41 PM , mm/dd/yyyy
	* OTHER
	* Using "-" separator instead of "/"
*</transform(datetime())>

*<ttoc(datetime(),1)> 20160507094015 </ttoc(datetime(),1)>
*<ttoc(datetime(),3>  2016-05-07T09:51:51 </ttoc(datetime(),3>	
TRY 
	LOCAL i,;
		lcChar_Parser,;
		lcChar_Sep,;
		lnd,;
		lnDay_Position,;
		lnh,;
		lnSeconds_Add,;
		lnYear_Position,;
		lcJust_Digits,;
		lt_return,;
		loResp as Object,;
		loex as Exception


	LOCAL ARRAY laFecha(3),laHora(3)
	IF tl_object
		loREsp = NEWOBJECT("Empty")
		ADDPROPERTY(loResp,"DateTime",{//::})
		ADDPROPERTY(loResp,"Fecha",CTOD(""))
		ADDPROPERTY(loResp,"Hora","00:00:00")
	ENDIF 	
	lnh = 0
	lnSeconds_Add = 0
	lt_return = {//::}
	lnYear_position = 1												&& 1,3 autodeterm
	tnMonth_Position = EVL(m.tnMonth_Position,_DEFAULT_PMONTH_)		&& puede ser 1  2
	lnDay_Position = 3												&& 1,2,3 autodeterm

	*!*	En los casos TRansform(datetime()) se necesita el parmetro tnMonth_Position
	*!*	Por default, tnMonth_Position = 2
	IF VARTYPE(tcDateTime)="N"
		tcDateTime = TRANSFORM(m.tcDateTime)
	ENDIF 
	tcDateTime = CHRTRAN(UPPER(ALLTRIM(EVL(m.tcDateTime , TTOC(DATETIME(),3) ))),_PUNTO_,"")
	lnSeconds_Add = IIF(RIGHT(m.tcDateTime,2)="PM",43200,0)

	lcJust_Digits = CHRTRAN(m.tcDateTime,CHRTRAN(m.tcDateTime,"1234567890",""),"")
	IF LEN(lcJust_Digits) > 7

		*!*	Si el caso es TTOC(Datetime(),1), se transforma a TTOC(Datetime(),3)
		*!*	Si tcDateTime = "yyyymmddhhmmss" se transforma a "yyyy-mm-ddThh:mm:ss"
		*!* Con Padr() se completa o restringe a 14 dgitos
		IF LEN(m.lcJust_Digits) = LEN(m.tcDateTime)
			tcDateTime = PADR(m.tcDateTime,14,"0")
			tcDateTime = TRANSFORM(LEFT(m.tcDateTime,8),"@R 9999-99-99") ;
				+"T" ;
				+TRANSFORM(RIGHT(m.tcDateTime,6),"@R 99:99:99")
		ENDIF 

		*!*		Separador Fecha Hora
		lcChar_Sep = ICASE(AT(_XMLTIME_,m.tcDateTime)>0,_XMLTIME_,;
						AT(_SPA_,m.tcDateTime)>0,_SPA_,;
						"")
						

		lcChar_Parser = LEFT(CHRTRAN( STREXTRACT(m.tcDateTime,"",m.lcChar_Sep) ,"1234567890",""),1)

		DO WHILE .t. 
			lnd = ALINES(laFecha,STREXTRACT(m.tcDateTime ,"",m.lcChar_Sep),1,m.lcChar_Parser)
			* Controla que los candidatos a year, month ,date, no estn vacos
			* si alguno est vaco, devuelve un datetime vacio.
			
			FOR i = 1 TO m.lnD
				IF EMPTY(laFecha[m.i])
					EXIT
				ENDIF 
			ENDFOR 
			IF len(m.lcChar_Sep) > 0
				lnh = ALINES(laHora,STREXTRACT(m.tcDateTime ,m.lcChar_Sep,""),1,_DOSPUN_)
			ENDIF 
			DO CASE 
				CASE LEN(laFecha[1]) = 4
					lnYear_Position = 1
					tnMOnth_position = 2
					lnDay_position = 3
				CASE LEN(laFecha[1]) = 2
					*!*	My be month or day
					
					IF !BETWEEN(m.tnMonth_position,1,2)
						tnMonth_Position = _DEFAULT_PMONTH_
					ENDIF 		
					lnYear_Position = 3
					lnDay_Position = m.lnYear_Position - m.tnMonth_Position
				OTHERWISE 
					EXIT 
			ENDCASE 

			* Quality Test 
			LOCAL ARRAY ladt(6)
			laDt[1] = VAL(laFecha[m.lnYear_Position])
			laDt[2] = VAL(laFecha[m.tnMonth_position])
			laDt[3] = VAL(laFecha[m.lnDay_Position])
			
			* Prevencin Fecha invlida
			IF EMPTY(DATE(laDt[1],laDt[2],laDt[3]))
				EXIT 
			ENDIF 
			
			laDt[4] = IIF(m.lnh>0,VAL(laHora[1]),0)
			laDt[5] = IIF(m.lnh>1,VAL(laHora[2]),0)
			laDt[6] = IIF(m.lnH>2,VAL(laHora[3]),0)

			* Verifica Validez de Segundos
			IF laDt[6] > 59
				lnSeconds_Add = m.lnSeconds_Add + INT(laDt[6]/60) * 60
				laDt[6] = laDt[6] - INT(laDt[6]/60) * 60
			ENDIF 
			
			* Verifica Validez de Minutos
			IF laDt[5] > 59
				lnSeconds_Add = m.lnSeconds_Add + INT(laDt[5]/60) * 3600
				laDt[5] = laDt[5] - INT(laDt[5]/60) * 60
			ENDIF 		
		
			* Verifica validez de hora
			IF laDt[4] > 23
				lnSeconds_Add = m.lnSEconds_Add + INT(laDt[4]/24) * 86400
				laDt[4] = laDt[4] - INT(laDt[4]/24) * 24
			ENDIF 

		
			lt_Return = DATETIME( ;
				laDt[1], ;
				laDt[2], ;
				laDt[3], ;
				laDt[4], ;
				laDt[5], ;
				laDt[6] ) ;
				+ lnSeconds_Add
				
	 		IF m.tl_Object
	 			loREsp.Datetime = m.lt_return
	 			loResp.fecha = TTOD(m.lt_return)
	 			loResp.Hora = TTOC(m.lt_return,2)
	 		ENDIF 
			EXIT 
		ENDDO 
	ENDIF 
CATCH TO loex
	loex.UserValue = PROGRAM()
	ShowError(loex)
FINALLY

ENDTRY 
RETURN IIF(m.tl_object,loResp,m.lt_Return)
ENDPROC

*****************************
PROCEDURE Cnv_amd_to_LitDate
*****************************
LPARAMETERS tcAmd
TRY 
	LOCAL loex as Exception,;
		lcReturn

	IF LEN(m.tcAmd) # 8
		lcReturn ="//"
	ELSE
		lcREturn = RIGHT(m.tcAmd,2)+"/";
			+SUBSTR(m.tcAmd,5,2)+"/";
			+LEFT(m.tcAmd,4)
	ENDIF
CATCH TO loex
	loex.UserValue = PROGRAM()
	ShowError(loex)

FINALLY

ENDTRY
RETURN lcReturn
ENDPROC

 

Procedure Create_ShortCut
*!*	--------------------------------------
*!*	Trata de crear un cono en el escritorio
*!*	a partir de solicitar las caractersticas
*!* Devuelve la ruta de aplicacin (para tcFolder_ini)
*!*	Ejemplo
*!*	Create_ShortCut(lcRoot,loFso)
*!*	-----------------------------------------
LPARAMETERS tcRoot,tcProgram_Name,toFso

TRY 
	LOCAL lcDescribe,;
		lcDeskTop,;
		cLink,;
		lDoit,;
		lcFileLink,;
		lcIcon_fileName,;
		lcProgram_exe,;
		loEX AS Exception,;
		olink AS Object,;
		oShell AS Object,;
		loReturn as Object


	loReturn = NEWOBJECT("Empty")
	ADDPROPERTY(loReturn,"Program_Name",m.tcProgram_Name)
	ADDPROPERTY(loReturn,"Folder_Reposit","")
	ADDPROPERTY(loReturn,"Folder_Ini","")
	lcDescribe = ""
	lcProgram_exe = ""
	lcIcon_FileName = ""
	lcFileLink = ""
	lcDesktop = WinDesk()
	
	DO WHILE .t.
		IF EMPTY(m.tcRoot) OR !DIRECTORY(ADDBS(m.tcRoot))
			EXIT 
		ENDIF 
		
		*<programa_ejecutable>
		IF EMPTY(m.tcProgram_Name)
			MESSAGEBOX("Se solicitar ahora que seleccione el programa que desea ejecutar en la carpeta de repositorio",0,MENSAJE_DE)
			tcProgram_name = GETFILE("exe","Programa a ejecutar")
			IF EMPTY(m.tcProgram_Name)
				EXIT
			ENDIF
			loReturn.Folder_Reposit = JUSTPATH(m.tcProgram_name)
			loREturn.Program_Name = JUSTFNAME(m.tcProgram_Name)
			
		ENDIF 
		*</programa_ejecutable>		
		*<Carpeta_destino>
		MESSAGEBOX("Se solicitar ahora que seleccione la carpeta en la que desea ejecutar el programa seleccionado",0,MENSAJE_DE)
		loReturn.Folder_Ini = GETDIR(FULLPATH(""),"Carpeta de ejecucin del Programa","Instalacin de "+PROPER(m.tcProgram_Name),64)
		IF EMPTY(loReturn.Folder_Ini)
			EXIT 
		ENDIF 
		IF RIGHT(loReturn.Folder_Ini,1)="\"
			loReturn.Folder_Ini = LEFT(loReturn.Folder_Ini,LEN(loReturn.Folder_Ini)-1)
		ENDIF 		
		*</Carpeta_destino>	
		

		lcProgram_exe = LOWER(ADDBS(m.tcRoot)+"theocall.exe")
		
		*<Ingresar_descripcin>
		lcDescribe = INPUTBOX("Descripcin","Descripcin de Icono de Escritorio","",0,"","")
		IF EMPTY(m.lcDescribe)
			EXIT
		ENDIF 
		lcDescribe = ALLTRIM(m.lcDescribe)
		*</Ingresar_descripcin>		
		
		*<Nombre_lnk>
		lcFileLink = FORCEEXT(ADDBS(m.lcDeskTop)+m.lcDescribe,"lnk")
		IF toFso.FileExists(m.lcFileLink)
			EXIT 
		ENDIF 
		*</Nombre_lnk>		
		
		*<Buscar_icono>
		MESSAGEBOX("Se solicitar ahora que asigne un cono de escritorio para el acceso directo",0,MENSAJE_DE)
		lcIcon_fileName = get_icono(loReturn.Folder_Ini)
		IF EMPTY(m.lcIcon_fileName)
			EXIT 
		ENDIF 
		*</Buscar_icono>
		
		*<Crea_shortcut>
		oShell = CreateObject('WScript.Shell')
*		DesktopPath = oShell.SpecialFolders('Desktop')
		oLink = oShell.CreateShortCut(m.lcFileLink)

		*oLink.Arguments = '1 2 3' && parameters 
		oLink.Arguments = loReturn.Folder_Ini +" /"+LOWER(loReturn.Program_Name)
		oLink.Description = m.lcDescribe
		oLink.HotKey = 'CTRL+ALT+SHIFT+X'
		oLink.IconLocation = m.lcIcon_fileName
		oLink.TargetPath = m.lcProgram_exe
		oLink.WindowStyle = 1
		oLink.WorkingDirectory = m.tcRoot
		oLink.Save()
		*</Crea_shortcut>
		EXIT
	ENDDO 
	

CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM() + CHR(13);
		+ "FileLink="+m.lcFileLink+ CHR(13);
		+ "Describe="+m.lcDescribe + CHR(13);
		+ "Ruta="+m.tcRoot + CHR(13);
		+ "folder_ini="+loReturn.Folder_Ini + CHR(13);
		+ "Program_exe="+m.lcProgram_exe + CHR(13);
		+ "Icon_filename="+m.lcIcon_FileName

	SHOWERROR(LOEX)

FINALLY
	oLink = null
	oShell = null
	RELEASE oLink,oShell
ENDTRY
RETURN loReturn

ENDPROC

PROCEDURE get_icono
*-----------------------
*!*	Devuelve el path + filename de un cono o bmp
*!*	Si no se selecciona una imagen, devuelve el String Vaco
LPARAMETERS tcFolder_ini
TRY 
	LOCAL LOEX AS EXCEPTION,;
		lcPicture,;
		lcCurDir
		
	lcCurDir = FULLPATH("")
	IF !EMPTY(m.tcFolder_Ini) AND DIRECTORY(m.tcFolder_Ini)
		CD (m.tcFolder_Ini)
	ENDIF 
	lcPicture = GETPICT("ico;bmp","Buscar Icono")

CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOWERROR(LOEX)

FINALLY
	IF !EMPTY(m.lcCurdir) ;
		AND DIRECTORY(m.lcCurDir)
		CD (m.lcCurDir)
	ENDIF 
ENDTRY
RETURN m.lcPicture
ENDPROC


PROCEDURE find_icon
*---------------------------------
LPARAMETERS tcProg
LOCAL lcDesk,lnfiles,i,lFound,;
	lcRoot ,lcProg,lcString
lcRoot = FULLPATH("")
lcDesk = Windesk()
lcRoot = ADDBS(lcRoot)

lnFiles = ADIR(laFiles,ADDBS(m.lcDesk)+"*.lnk","H",1)
FOR i=1 TO lnfiles
	lcLink = ADDBS(m.lcDesk)+lafiles[i,1]
	lcString = FILETOSTR(lcLink)
	IF ATC(tcProg,m.lcString) > 0 AND ATC(lcRoot,m.lcString) > 0
		* Ya hay un cono
		lFound = .t.
		EXIT 
	ENDIF
NEXT
	
RETURN lFound





PROCEDURE insert_tag
*--------------------
* Insertar una tag en un archivo plano de mltiples atributos
*!*	tcAttrib		Nombre de Tag - 
*!*					Ejemplo1: "folderback"
*!*					Ejemplo2: "pjx name="c:\theodore\theodore.pjx"
*!*	tcTag_Full			Tag que se inserta (completo) - 
*!*					Ejemplo1 "<folder>c:\theodore\libs</folder>"
*!*					Ejemplo2 [<pjx name="c:\theoven\theoven.pjx"><juststem>Theoven</juststem><fullname>c:\theoven\theoven.pjx</fullname><external_bin>.F.</external_bin></pjx>]
*!*	tcFileConfig 	Path + filename + extension del archivo al que se modifica
*!*	--------------------------------------------------------------------------------
*!*	Insert_Tag(lcProgram,Put_Tag("folder",lcFolder),loParam.File_Info)
*!*	--------------------------------------------------------------------------------
LPARAMETERS tcAttrib,tcTag_Full,tcfileConfig
TRY 
	LOCAL LOEX AS EXCEPTION,;
		lcString_Attrib,;
		lcString_delete,;
		lcString_Content,;
		lcString,;
		lnLines,;
		i,;
		lDoit,;
		loTags as Object
		
	LOCAL ARRAY lalines(1)
			
	
	tcAttrib = LOWER(ALLTRIM(m.tcAttrib))
	lcString_Attrib = ""
	lcString_Content = ""
	
	loTags = Detectar_Tags(m.tcTag_Full,.t.)
	lDoit = VARTYPE(loTags)="O"
	
	IF m.lDoit
		*pjx name="c:\theodore\theodore.pjx"
		*</pjx>	
		
		lcAttrib_Ini = CHR(60)+m.tcAttrib+CHR(62)
		lcAttrib_end = CHR(60)+CHR(47) ;
				+ IIF(AT(CHR(32),m.tcAttrib) > 0 ,;
				STREXTRACT(m.tcAttrib,"",CHR(32),1) ,;
				m.tcAttrib) ;
				+ CHR(62)
				
		lcSTring_Attrib = Delete_Tag_Value(m.tcAttrib,loTags.tag,m.tcfileConfig,.f.)
		
		lnLines = ALINES(lalines,m.lcString_Attrib,1+4,CHR(9),CHR(10),CHR(13))

		lcString = Put_Tag(m.tcAttrib,null,0,1)
		FOR i = 1 TO m.lnLines
			lcSTring = m.lcString ;
				+ laLines[i]+CHR(13)+CHR(10)
		NEXT
		lcString = m.lcSTring ;
			+ m.tcTag_Full ;
			+ CHR(13)+CHR(10);
			+ Put_Tag("/"+m.tcAttrib,null,0,1)
		STRTOFILE(m.lcString,m.tcFileConfig,1)
	ENDIF 
CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOWERROR(LOEX)

FINALLY
	loTags = null
ENDTRY

PROCEDURE delete_tag_Value
*-----------------------------------------
LPARAMETERS tcAttrib,tcTag_Name,tcfileConfig,tlDelete
TRY 
	LOCAL i,;
		lcString_Attrib,;
		lcString_Content,;
		lcString_Delete,;
		lcTag_Return,;
		lDoit,;
		LOEX AS EXCEPTION,;
		loTags AS Object,;
		loAttrib as Object
		


	lcString_Attrib = ""
	lDoit = FILE(m.tcFileConfig)	
	IF m.lDoit
		lDoit = !EMPTY(m.tcAttrib)
	ENDIF
	IF m.lDoit
		lDoit = !EMPTY(m.tcTag_Name)
	ENDIF 

	IF m.lDoit

		loAttrib = Detectar_Tags(m.tcAttrib)
		lDoit = VARTYPE(loAttrib)="O"
	ENDIF 
	IF m.lDoit

		loTags = detectar_Tags(m.tcTag_name,.f.)
		lDoit = VARTYPE(loTags)="O"
	ENDIF
	IF m.lDoit 
		
		lcString_Attrib = STREXTRACT(FILETOSTR(m.tcFileConfig),loAttrib.Tag_ini,loAttrib.Tag_End)

		lcString_Delete = STREXTRACT(FILETOSTR(m.tcFileConfig),loAttrib.Tag_ini,loAttrib.Tag_End+CHR(13)+CHR(10),1,4)
		
		lcString_Content = STREXTRACT(m.lcSTring_Attrib,loTags.Tag_Ini,loTags.Tag_End+CHR(13)+CHR(10),1,4)
		
*!*			MESSAGEBOX(m.lcString_Content+CHR(13);
*!*				+ loTags.Tag_Ini + CHR(13);
*!*				+ loTags.Tag_End + CHR(13);
*!*				+ m.tcAttrib + CHR(13);
*!*				+ m.tcTag_Name)
		
		IF !EMPTY(m.lcString_Delete)
			lcExtract = FILETOSTR(m.tcFileConfig)
			STRTOFILE(STRTRAN(m.lcExtract,m.lcString_Delete,""),m.tcFileConfig,0)
		ENDIF 

		lcString_Attrib = STRTRAN(m.lcSTring_attrib,m.lcString_Content,"")		

		IF m.tlDelete
			lnLines = ALINES(lalines,m.lcString_Attrib,1+4,CHR(9),CHR(10),CHR(13))

			lcString = Put_Tag(loAttrib.tag,null,0,1)
			FOR i = 1 TO m.lnLines
				lcSTring = m.lcString ;
					+ laLines[i]+CHR(13)+CHR(10)
			NEXT
			lcString = m.lcSTring ;
				+ Put_Tag("/"+loAttrib.tag,null,0,1)
				
			STRTOFILE(m.lcString,m.tcFileConfig,1)		
		
		
		ENDIF 

	ENDIF 
CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOWERROR(LOEX)

FINALLY
	loTags = null
	loAttrib = null
ENDTRY
RETURN m.lcString_Attrib
ENDPROC

PROCEDURE Detectar_Tags
*------------------------
* Devuelve un objeto con
* tag	(tag_name) folder	pjx name="pepe"
* Tag_ini	<folder>	<pjx name="pepe">
* tag_end	</folder>	</pjx>
* --------------------------------------
LPARAMETERS tcTag,tlFull
TRY 
	LOCAL LOEX AS EXCEPTION,;
		loResp as Object
		
	loResp = NEWOBJECT("Empty")
	ADDPROPERTY(loResp,"tag","")
	ADDPROPERTY(loResp,"tag_Ini","")
	ADDPROPERTY(loResp,"tag_End","")
	
	loResp.Tag = LOWER(ALLTRIM(IIF(m.tlfull,STREXTRACT(m.tcTag,"<",">",1),m.tcTag)))
	loResp.Tag_Ini = CHR(60)+loResp.Tag+CHR(62)
	loResp.Tag_End =  CHR(60)+CHR(47) ;
				+ IIF(AT(CHR(32),loResp.Tag) > 0 ,;
				STREXTRACT(loResp.Tag ,"",CHR(32),1) ,;
				loResp.Tag) ;
				+ CHR(62)

CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOWERROR(LOEX)

FINALLY

ENDTRY
RETURN loResp
ENDPROC 

PROCEDURE get_tag_value
*!* ----------------------------------------------------------------------------------------------------------------------------------------
*!*	tcAttrib		Nombre de Tag - 
*!*					Ejemplo1: [folderback]
*!*					Ejemplo2: [pjx name="c:\theodore\theodore.pjx"]
*!*	tcTag_Name		Tag de la que se busca el valor contenido
*!*					Ejemplo1 [folder]
*!*					Ejemplo2 [pjx name="c:\theoven\theoven.pjx"]
*!*	tcFileConfig 	Path + filename + extension del archivo al que se modifica
*!*			this.folderback = get_tag_value(this.attrib_folderbak,"folder",this.fileconfig)
*!*			this.foxbindir = get_tag_value(this.attrib_foxbindir,"folder",this.fileconfig)
*!* ----------------------------------------------------------------------------------------------------------------------------------------
*!* get_Tag_Value(lcProgram,"reposit",toParam.File_Info)
*!* ----------------------------------------------------------------------------------------------------------------------------------------
LPARAMETERS tcAttrib,tcTag_Name,tcfileConfig

TRY 
	LOCAL LOEX AS EXCEPTION,;
		lcTag_Return,;
		lDoit,;
		lcString_Content,;
		loTags as Object,;
		loAttrib as Object
	
	lcTag_return = ""
	lDoit = FILE(m.tcFileConfig)	
	IF m.lDoit
		lDoit = !EMPTY(m.tcAttrib)
	ENDIF

	IF m.lDoit
		loAttrib = Detectar_Tags(m.tcAttrib)
		lDoit = VARTYPE(loAttrib)="O"
	ENDIF 
	
		
	IF !EMPTY(m.tcTag_Name)
		loTags = Detectar_Tags(m.tcTag_name,.f.)
		
	ENDIF 	
 			
	IF m.lDoit
		lcString_Content = STREXTRACT(FILETOSTR(m.tcFileConfig),loAttrib.Tag_Ini,loAttrib.Tag_end)
		IF !EMPTY(m.tcTag_Name) 
			IF VARTYPE(loTags)="O"
				lcTag_REturn = STREXTRACT(m.lcString_Content,loTags.Tag_Ini,loTags.Tag_End,1)
			ENDIF 
		ELSE
			lcTag_Return = m.lcString_Content + CHR(13) + CHR(10)
		ENDIF 
	
	
	ENDIF 
CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOWERROR(LOEX)

FINALLY
	loTags = null
	loAttrib = null
ENDTRY
RETURN m.lcTag_Return
ENDPROC


PROCEDURE get_fdb_semaf
************************
LPARAMETERS tcMain,tcFolder
** cONTROl de Uso de la Version
*!*	App
*!*	Autor: Fernando D. Bozzo
*!*	Date:	25/01/2015 en Comunidad
tcMain = PROPER(m.tcMain)
tcFolder = EVL(m.tcFolder,MiCurDir())

ADDPROPERTY(_screen,"osemaf",NEWOBJECT("fun_semaforos", "lib_semaforos.vcx"))
lnREsp = _SCreen.oSemaf.semaforo_Crear(m.tcMain+"_"+get_LastFolder(m.tcFolder))
IF lnREsp = 0
	_Screen.osemaf = null
	MESSAGEBOX(m.tcMain+" ya est abierto en "+m.tcFolder,0,"Mensaje de FoxBin_Join",1000)

	ON SHUTDOWN
	QUIT
ENDIF 
*!*	? oo.semaforo_Crear("P1") && Devuelve 1 si lo crea, y 0 si no lo puede crear.
*!*	* En este caso te devolver 1
*!*	El archivo dbchek.dbf pasa a estar Incluido en el proyecto
RETURN
ENDPROC 

PROCEDURE get_LastFolder
************************
LPARAMETERS tcPath ,tnFlag ,tnLevels
TRY 

	LOCAL LOEX AS EXCEPTION,;
	lnLines,lcLast_Folder , lAddSlash,i,;
	lcFolder
	
	LOCAL ARRAY lalines(1)
	
	tnLevels = EVL(tnLevels,1)
	tnFlag = EVL(tnFlag,0)

	lcFolder = ""
	lcLast_Folder=""

	IF tnFlag>3
		tnFlag=tnFlag - 4
		lAddSlash=.t.
	ENDIF

	lnLines=ALINES(lalines,tcPath,1+4,"\")	
	IF m.tnLevels > (m.lnLines-1)
		tnLevels = m.lnLines - 1
	ENDIF 
	LOCAL ARRAY laLevels(m.lnLines)
		
	IF m.lnLInes > 0
		IF m.tnLevels = 1
			lcLast_Folder=laLines[lnLines]
		ELSE 
			FOR i = m.lnLines TO m.tnLevels STEP  - 1
				laLevels[i]=laLines[i]
			NEXT 
			FOR i = m.lnLines - m.tnLevels + 1 TO m.lnLines
				IF !EMPTY(laLevels[m.i])
					lcLast_Folder = m.lcLast_Folder ;
						+ IIF(EMPTY(m.lcLast_Folder),"","\") ;
						+ laLevels[i]
				ENDIF 
			NEXT 
		
		ENDIF 

	ENDIF
	
	lcFolder = IIF(m.lAddSlash,"\","") ;
		+ICASE(m.tnFlag=1 , LOWER(m.lcLast_Folder),;
			m.tnFlag=2 , UPPER(m.lcLast_Folder),;
			m.tnFlag=3 , PROPER(m.lcLast_Folder),m.lcLast_Folder)
	
	
CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOWERROR(LOEX)

FINALLY

ENDTRY
RETURN m.lcFolder
ENDPROC